﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Diagnostics;

namespace XamComboEditorDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataTable _dtDimensions = new DataTable();

        public MainWindow()
        {
            InitializeComponent();

                                   
            _dtDimensions.Columns.Add("Column1");
            _dtDimensions.Columns.Add("Column2");
            _dtDimensions.Columns.Add("Column3");

            _dtDimensions.Rows.Add(new object[] { "Value1" });
            _dtDimensions.Rows.Add(new object[] { "Value2"});
            _dtDimensions.Rows.Add(new object[] { "Value3" });
            
            xdgDimensions.DataSource = _dtDimensions.DefaultView;
        
            DataTable _dtDestDims = new DataTable();
            _dtDestDims.Columns.Add("Field");
            _dtDestDims.Columns.Add("Label");
            //_dtDestDims.Rows.Add(new object[] { "Please Select", "Please Select" });
            _dtDestDims.Rows.Add(new object[] { "Item1", "ValueItem1" });
            _dtDestDims.Rows.Add(new object[] { "Item2", "ValueItem2" });
            _dtDestDims.Rows.Add(new object[] { "Item3", "ValueItem3" });

            ComboBoxItemsProvider cbipDestDimsProvider = this.TryFindResource("cbipDestDims") as ComboBoxItemsProvider;
            cbipDestDimsProvider.ItemsSource = _dtDestDims.DefaultView;
            //cbipDestDimsProvider.DisplayMemberPath = "Label";
            cbipDestDimsProvider.ValuePath = "Field";
            xdgDimensions.Records.FieldLayout.Fields["Column2"].Settings.EditorStyle = (Style)this.TryFindResource("ComboStyle");
            xdgDimensions.Records.FieldLayout.Fields["Column2"].Width = new FieldLength(300);
            xdgDimensions.Records.FieldLayout.Fields["Column2"].Settings.AllowEdit = true;
            xdgDimensions.Records.FieldLayout.Fields["Column2"].Settings.CellClickAction = CellClickAction.EnterEditModeIfAllowed;
        }
              
        private void cmbDimension_DropDownClosed(object sender, RoutedEventArgs e)
        {
            if (sender.GetType() == typeof(XamComboEditor))
            {
                if ((sender as XamComboEditor).HasValueChanged)
                {
                    (sender as XamComboEditor).EndEditMode(true, true);
                }
                else
                {
                    (sender as XamComboEditor).EndEditMode(false, true);
                }
            }


        }

        private void cmbDimension_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            try
            {
                if (sender.GetType() == typeof(XamComboEditor)) //&& (sender as XamComboEditor).SelectedItem != null && xdgDimensions.ActiveCell != null)
                {
                    xdgDimensions.ActiveCell.Record.Cells["Column2"].Value = (sender as XamComboEditor).Text;
                    //xdgDimensions.ActiveCell.Record.Cells["Column2"].Tag = ((sender as XamComboEditor).SelectedItem as DataRowView).Row.ItemArray[0];
                    xdgDimensions.ActiveCell.Record.Cells["Column3"].Value = (sender as XamComboEditor).Value;
                    xdgDimensions.ExecuteCommand(DataPresenterCommands.EndEditModeAndCommitRecord);
                    (sender as XamComboEditor).SelectedItem = (sender as XamComboEditor).SelectedItem;
                    _dtDimensions.AcceptChanges();
                }

            }
            catch (Exception ex)
            { MessageBox.Show(ex.Message); }
        }

        private void cmbDimension_TextChanged(object sender, RoutedPropertyChangedEventArgs<string> e)
        {
        }

     

        private void xdgDimensions_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {

            //getFilterString();
        }
    }

    public class TemplateSelector:DataTemplateSelector
    {
        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            XamComboEditor editor = Utilities.GetAncestorFromType(container, typeof(XamComboEditor), true) as XamComboEditor;
            DataView dv = editor.ItemsProvider.ItemsSource as DataView;
            if ((item as DataRowView).Row.ItemArray[1] == dv.Table.Rows[dv.Table.Rows.Count - 1].ItemArray[1])
            {
                return App.Current.TryFindResource("hyperlinkTemplate") as DataTemplate;
            }
            return App.Current.TryFindResource("regularTemplate") as DataTemplate;
        }
    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                return value;
            }
            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }


}
